import Data.List
import Data.List.Ordered

passcodes = length [ x | x <- [254042 .. 789860], ascending x, adjacents x]
  where ascending = isSorted . show
        adjacents num = any (\digit -> length digit >= 2) (group $ show num)
