import Data.List
import Data.List.Split
import Data.List.HT

count :: Eq a => a -> [a] -> Int
count a = foldr (\x sum -> if x == a then sum + 1 else sum) 0

main = do
  layers <- readFile "input" >>= (\x -> pure $ sortBy (\a b -> compare (count '0' a) (count '0' b)) $ dropRev 1 $ (chunksOf (25 * 6) x))
  putStrLn $ show $ (count '1' $ head layers) * (count '2' $ head layers)

